<?php

/**
 * co_carac_detalle_hijos actions.
 *
 * @package    contratacion
 * @subpackage co_carac_detalle_hijos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_carac_detalle_hijosActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CARAC_DETALLE_HIJOS_V',
        'CO_TIPO_IDEN',
        'CO_CARAC_CONTRATISTA_V',
        'CO_CONTRATISTA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_TIPO_IDEN,LEFT' =>
        array(
            'id_tipo_iden' => 'CO_CARAC_DETALLE_HIJOS_V'
        ),
        'CO_CARAC_CONTRATISTA_V,LEFT' =>
        array(
            'id_carac_contratista' => 'CO_CARAC_DETALLE_HIJOS_V'
        ),
        'CO_CONTRATISTA,LEFT' =>
        array(
            'id_contratista' => 'CO_CARAC_CONTRATISTA_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CARAC_DETALLE_HIJOS_V' =>
        array(
            'id_carac_detalle_hijos' => 'id_carac_detalle_hijos',
            'id_carac_contratista' => 'id_carac_contratista',
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'nombre' => 'nombre',
            'genero' => 'genero',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'genero_text' => 'genero_text'
        ),
        'CO_TIPO_IDEN' =>
        array(
            'descripcion' => 'tipo_iden'
        ),
        'CO_CARAC_CONTRATISTA_V' =>
        array(
            'id_contratista' => 'id_contratista'
        ),
        'CO_CONTRATISTA' =>
        array(
            'num_doc' => 'num_doc_contra',
            'dv' => 'dv',
            'nombre_razon' => 'nombre_razon'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_carac_contratista', 'fecha_nacimiento', 'num_doc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CARAC_DETALLE_HIJOS_V' =>
        array(
            'id_carac_detalle_hijos,a' => array('!=' => array(-1)),
            'id_carac_detalle_hijos,b' => array('=' => array('id_carac_detalle_hijos')),
            'id_carac_contratista' => array('=' => array('id_carac_contratista')),
            'id_tipo_iden' => array('=' => array('id_tipo_iden')),
            'genero' => array('=' => array('genero')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//   protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_carac_detalle_hijos'; //identificador de la tabla
    protected $id_names = array('id_carac_detalle_hijos'); //llave primaria
    protected $field_names = array('id_carac_contratista', 'id_tipo_iden', 'num_doc', 'nombre',
        'genero', 'fecha_nacimiento'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CARAC_DETALLE_HIJOS'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_carac_contratista'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_carac_contratista = $list_data_post[0]['id_carac_contratista'];

                $sql = <<<EOD
update co_carac_contratista 
set hijos = nvl( (select count(id_carac_detalle_hijos) from co_carac_detalle_hijos where id_carac_contratista = $id_carac_contratista) ,0)                
where
id_contratista in (select id_contratista from co_carac_contratista where id_carac_contratista = $id_carac_contratista) 
EOD;
                $this->conn->execute($sql);


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            try {

                $id_carac_contratista = $request['id_carac_contratista'];

                $sql = <<<EOD
update co_carac_contratista 
set hijos = nvl( (select count(id_carac_detalle_hijos) from co_carac_detalle_hijos where id_carac_contratista = $id_carac_contratista) ,0)                
where
id_contratista in (select id_contratista from co_carac_contratista where id_carac_contratista = $id_carac_contratista) 
EOD;
                $this->conn->execute($sql);


                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        //Obtener variable para actualizar cant hijos
        $id_carac_detalle_hijos = $request['id_carac_detalle_hijos'];
        $sql = <<<EOD
select id_carac_contratista from co_carac_detalle_hijos where id_carac_detalle_hijos = $id_carac_detalle_hijos  
EOD;
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0) {
            $request['id_carac_contratista'] = $records[0]['id_carac_contratista'];
        }

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
